static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xFF, 0x7E, 0x03, 0x43, 0x82, 0x87, 0xE4, 0x31, 0xC5, 0xDF,
        0xBB, 0x6C, 0x85, 0x02, 0xAA, 0x4A, 0xE2, 0x83, 0x3C, 0x95,
        0xEC, 0x2D, 0xD4, 0x10, 0x2C, 0x05, 0x3B, 0xB5, 0x2A, 0xC2,
        0xD3, 0x33, 0x9F, 0xA1, 0xC7, 0x98, 0x17, 0x4E, 0x54, 0xFF,
        0x92, 0xF4, 0x38, 0x08, 0x85, 0xFC, 0x48, 0x7D, 0xDC, 0xC3,
        0x33, 0x44, 0x4F, 0xD3, 0xCC, 0x13, 0xB3, 0x6B, 0x0D, 0x9E,
        0x0C, 0x92, 0x87, 0x9B
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
